#include "xiao_display.h"
#include "WiFi.h"

xiao_display d;
NetworkServer server(80);
NetworkClient client;

void setup() {
  Serial.begin(115200);
  Serial.println();

  if (!xiao_display_init(&d)) {
    Serial.println("Failed to start display");
    while (1)
      ;
  }
  Serial.println("display started");

  if (!WiFi.softAP("esp_server")) {
    log_e("Soft AP creation failed.");
    while (1)
      ;
  }
  IPAddress myIP = WiFi.softAPIP();
  Serial.print("AP IP address: ");
  Serial.println(myIP);

  server.begin();
  Serial.println("Server started");
}

bool play = false;

void loop() {
  uint8_t x, y;
  static bool touched = false;
  bool touching = xiao_display_get_touch(&d, &x, &y);

  bool connected = false;

  if (!client) client = server.accept();
  if (client) {
    connected = true;

    if (client.available()) {
      String msg = client.readStringUntil('\n');
      Serial.println(msg);
    }

    if (!touched && touching) {
      client.print(play ? "0\n" : "440\n");
      play = !play;
    }
  }

  d.gfx->fillScreen(WHITE);
  d.gfx->setCursor(70, 70);
  d.gfx->setTextSize(3);
  d.gfx->print(connected ? "Connected" : "Waiting");
  d.gfx->flush();
  touched = touching;
}
